/*  BotikKey Pro - Botik Key Client for Windows 9x/ME/NT/2000/XP/2003
 *  Copyright (C) 2004 Alexander V. Melnikoff
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public Licensse as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

#include "stdafx.h"

BOOL AddNotifyIcon(HWND hWnd_, UINT uID_, UINT uIcon_)
{
	NOTIFYICONDATA	nid;
	BOOL			fRet;
	HICON			hIcon;

	hIcon = (HICON)LoadImage(g_hInst, MAKEINTRESOURCE(uIcon_), IMAGE_ICON, 16, 16, 0);

	nid.cbSize = sizeof(NOTIFYICONDATA);
	nid.hWnd   = hWnd_;
	nid.uID    = uID_;
	nid.uFlags = NIF_ICON|NIF_MESSAGE|NIF_TIP;
	nid.hIcon  = hIcon;
	nid.uCallbackMessage = WM_USER_NOTIFYICON;
	_tcscpy(nid.szTip, ABK_MANAGER_NAME);

	fRet = Shell_NotifyIcon(NIM_ADD, &nid);

	DestroyIcon(hIcon);

	return(fRet);
};

BOOL ModNotifyIcon(HWND hWnd_, UINT uID_, UINT uIcon_)
{
	NOTIFYICONDATA	nid;
	BOOL			fRet;
	HICON			hIcon;

	cfdprintf("ModNotifyIcon: %d", uIcon_);

	hIcon = (HICON)LoadImage(g_hInst, MAKEINTRESOURCE(uIcon_), IMAGE_ICON, 16, 16, 0);

	nid.cbSize = sizeof(NOTIFYICONDATA);
	nid.hWnd   = hWnd_;
	nid.uID    = uID_;
	nid.uFlags = NIF_ICON;
	nid.hIcon  = hIcon;

	fRet = Shell_NotifyIcon(NIM_MODIFY, &nid);

	DestroyIcon(hIcon);

	return(fRet);
};

BOOL DelNotifyIcon(HWND hWnd_, UINT uID_)
{
	NOTIFYICONDATA	nid;

	nid.cbSize = sizeof(NOTIFYICONDATA);
	nid.hWnd   = hWnd_;
	nid.uID    = uID_;
	nid.uFlags = 0;

	return(Shell_NotifyIcon(NIM_DELETE, &nid));
};

BOOL ShowBalloonNotifyIcon(HWND hWnd_, UINT uID_, DWORD dwType_, LPTSTR szTitle_, LPTSTR szMsg_)
{
	NOTIFYICONDATA nid;

	memset(&nid, 0, sizeof(NOTIFYICONDATA));
	nid.cbSize   = sizeof(NOTIFYICONDATA);
	nid.hWnd     = hWnd_;
	nid.uFlags   = NIF_INFO;
	nid.uID      = uID_;
	nid.uTimeout = 30000;
	nid.dwInfoFlags = dwType_;

	_tcsncpy(nid.szInfoTitle, szTitle_, cfTCBLENGTH(nid.szInfoTitle));
	_tcsncpy(nid.szInfo, szMsg_, cfTCBLENGTH(nid.szInfo));

	return(Shell_NotifyIcon(NIM_MODIFY, &nid));
};

