/*  BotikKey Pro - Botik Key Client for Windows 9x/ME/NT/2000/XP/2003
 *  Copyright (C) 2004 Alexander V. Melnikoff
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public Licensse as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

// pwd2key.cpp : Defines the entry point for the application.
//

#include "stdafx.h"
#include <htmlhelp.h>
#include "pwd2key.h"

// Global Variables:
HINSTANCE	g_hInst;		// Current instance
HWND		g_hMainDlg;
HICON		g_hBigIcon;
HICON		g_hSmallIcon;
HKEY		g_hKeyCurUsr;
HKEY		g_hKeyLocMch;
TCHAR		g_szChmPath[MAX_PATH+30]; // add size of ::02_pw2key.html

// Config...
BOOL		g_fPwdAsterisks;
BOOL		g_fKeyAsterisks;
DWORD		g_nPasswdPlace;
CHAR		g_szHash[ABK_MD5_HASH_LEN+2];

// Forward declarations of functions included in this code module:
LRESULT CALLBACK	WndProc(HWND, UINT, WPARAM, LPARAM);

int APIENTRY _tWinMain(HINSTANCE hInstance_,
                       HINSTANCE hPrevInstance_,
                       LPTSTR    lpCmdLine_,
                       INT       nCmdShow_)
{
	MSG msg;
	LONG lRet;
	INITCOMMONCONTROLSEX icce;

	g_hInst = hInstance_;

	icce.dwSize = sizeof(INITCOMMONCONTROLSEX);
	icce.dwICC  = ICC_ANIMATE_CLASS|ICC_BAR_CLASSES|ICC_COOL_CLASSES|ICC_DATE_CLASSES|ICC_HOTKEY_CLASS|
					ICC_INTERNET_CLASSES|ICC_LINK_CLASS|ICC_LISTVIEW_CLASSES|ICC_NATIVEFNTCTL_CLASS|
					ICC_PAGESCROLLER_CLASS|ICC_PROGRESS_CLASS|ICC_STANDARD_CLASSES|ICC_TAB_CLASSES|
					ICC_TREEVIEW_CLASSES|ICC_UPDOWN_CLASS|ICC_USEREX_CLASSES|ICC_WIN95_CLASSES;

	InitCommonControlsEx(&icce);

	GetModuleFileName(g_hInst, g_szChmPath, MAX_PATH);
	*_tcsrchr(g_szChmPath, _T('\\')) = _T(0);
	_tcscat(g_szChmPath, _T("\\help.chm::/html/02_pw2key.html"));

	// Read config.
	// Opens registry keys to read settings.
	lRet = RegCreateKeyEx(HKEY_CURRENT_USER, REG_SETTINGS_PATH, 0, NULL, 
						  REG_OPTION_NON_VOLATILE, KEY_WRITE|KEY_READ, 
						  NULL, &g_hKeyCurUsr, NULL);
	cfCHECK_RET(lRet);

	lRet = RegCreateKeyEx(HKEY_LOCAL_MACHINE, REG_SETTINGS_PATH, 0, NULL, 
						  REG_OPTION_NON_VOLATILE, KEY_WRITE|KEY_READ, 
						  NULL, &g_hKeyLocMch, NULL);
	cfCHECK_RET(lRet);

	cfRegReadDWVal(g_hKeyCurUsr, REG_PWD_ASTERISKS_VAL, (LPDWORD)&g_fPwdAsterisks, 1);
	cfRegReadDWVal(g_hKeyCurUsr, REG_KEY_ASTERISKS_VAL, (LPDWORD)&g_fKeyAsterisks, 1);
	cfRegReadDWVal(g_hKeyLocMch, REG_PASSWD_PLACE_VAL, (LPDWORD)&g_nPasswdPlace, 0);

	g_hMainDlg = CreateDialog(g_hInst, MAKEINTRESOURCE(IDD_MAIN_DLG), NULL, (DLGPROC)WndProc);

	if(!g_hMainDlg)
	{
		cfdprintf("CreateDialog failed.: %d", GetLastError());
		return(FALSE);
	};

	ShowWindow(g_hMainDlg, SW_SHOW);
	UpdateWindow(g_hMainDlg);

	// Main message loop:
	while(GetMessage(&msg, NULL, 0, 0)) 
	{
		TranslateMessage(&msg);
		DispatchMessage(&msg);
	};

	// Save config...
	cfRegSaveDWVal(g_hKeyCurUsr, REG_PWD_ASTERISKS_VAL, g_fPwdAsterisks);
	cfRegSaveDWVal(g_hKeyCurUsr, REG_KEY_ASTERISKS_VAL, g_fKeyAsterisks);

	RegCloseKey(g_hKeyCurUsr);
	RegCloseKey(g_hKeyLocMch);

	return((INT) msg.wParam);
};

//
//  FUNCTION: WndProc(HWND, unsigned, WORD, LONG)
//
//  PURPOSE:  Processes messages for the main window.
//
//  WM_COMMAND	- process the application menu
//  WM_PAINT	- Paint the main window
//  WM_DESTROY	- post a quit message and return
//
//
LRESULT CALLBACK WndProc(HWND hWnd_, UINT uMsg_, WPARAM wParam_, LPARAM lParam_)
{
	switch (uMsg_)
	{
	case WM_INITDIALOG:
		g_hBigIcon = LoadIcon(g_hInst, MAKEINTRESOURCE(IDI_PWD2KEY));
		SendMessage(hWnd_, WM_SETICON, ICON_BIG, (LPARAM)g_hBigIcon);

		g_hSmallIcon = (HICON)LoadImage(g_hInst, MAKEINTRESOURCE(IDI_PWD2KEY), IMAGE_ICON, 16, 16, 0);
		SendMessage(hWnd_, WM_SETICON, ICON_SMALL, (LPARAM)g_hSmallIcon);

		SendDlgItemMessage(hWnd_, IDC_PASSWD, EM_SETPASSWORDCHAR, 
						   (WPARAM)(g_fPwdAsterisks ? _T('*') : _T(0)), 0);

		SendDlgItemMessage(hWnd_, IDC_KEY, EM_SETPASSWORDCHAR, 
						   (WPARAM)(g_fKeyAsterisks ? _T('*') : _T(0)), 0);

		SendDlgItemMessage(hWnd_, IDC_PWD_ASTERISKS_CHECK, BM_SETCHECK, g_fPwdAsterisks, 0);
		SendDlgItemMessage(hWnd_, IDC_KEY_ASTERISKS_CHECK, BM_SETCHECK, g_fKeyAsterisks, 0);

		md5_md5((LPBYTE)"", (ULONG)strlen(""), g_szHash);

		SetDlgItemTextA(hWnd_, IDC_KEY, g_szHash);

		/*if(g_nPasswdPlace == ABK_PASSWD_PLACE_SELF)
			SendDlgItemMessage(hWnd_, IDC_PWD_RADIO1, BM_CLICK, 1, 0);
		else if(g_nPasswdPlace == ABK_PASSWD_PLACE_ENV)
			SendDlgItemMessage(hWnd_, IDC_PWD_RADIO2, BM_CLICK, 1, 0);
		else */if(g_nPasswdPlace == ABK_PASSWD_PLACE_REG)
			SendDlgItemMessage(hWnd_, IDC_RADIO1, BM_CLICK, 1, 0);
		else if(g_nPasswdPlace == ABK_PASSWD_PLACE_DEF_FILE)
			SendDlgItemMessage(hWnd_, IDC_RADIO2, BM_CLICK, 1, 0);
		else if(g_nPasswdPlace == ABK_PASSWD_PLACE_SELF_FILE)
			SendDlgItemMessage(hWnd_, IDC_RADIO3, BM_CLICK, 1, 0);

		if(g_nPasswdPlace > 0)
			cfEnableDlgItem(hWnd_, ID_SAVE, TRUE);
		else
			cfEnableDlgItem(hWnd_, ID_SAVE, FALSE);

		return(TRUE);

	case WM_COMMAND:
		switch(LOWORD(wParam_))
		{
		case IDHELP:
			HtmlHelp(HWND_DESKTOP/*g_hMainDlg*/, g_szChmPath, HH_DISPLAY_TOPIC, NULL);
			break;

		case IDC_BROWSE:
			if(HIWORD(wParam_) == BN_CLICKED)
			{
				TCHAR	szFile[MAX_PATH+1];
				TCHAR	szTitle[MAX_LOADSTRING];
				TCHAR	szFilter[MAX_LOADSTRING];

				ZeroMemory(szFilter, sizeof(szFilter));

				LoadString(g_hInst, IDS_FILE_FILTER, szFilter, MAX_LOADSTRING);
				LoadString(g_hInst, IDS_OPEN_KEY_FILE_TITLE, szTitle, MAX_LOADSTRING);

				if(ShowOpenFileDlg(hWnd_, szFile, MAX_PATH, szFilter, szTitle, 0))
				{
					cfdprintf("File: %s", szFile);

					HANDLE hFile = CreateFile(szFile, GENERIC_READ, FILE_SHARE_READ, NULL, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, NULL);
					
					if(hFile == INVALID_HANDLE_VALUE)
					{
						// XXX
						cfAlertBoxError(_T("BotikKey Pro..."),
											_T("    ."), GetLastError());
					}
					else
					{
						DWORD dwFileSize;

						dwFileSize = GetFileSize(hFile, NULL);
						if(dwFileSize == 0)
						{
							// XXX
							cfAlertBoxError(_T("BotikKey Pro..."),
											_T("  ."), GetLastError());
						}
						else
						{
							DWORD dwReadedSz;

							ZeroMemory(g_szHash, sizeof(g_szHash));

							SetDlgItemText(hWnd_, IDC_PASSWD, _T(""));

							if(!ReadFile(hFile, g_szHash, ABK_MD5_HASH_LEN, &dwReadedSz, NULL))
							{
								// XXX
								cfAlertBoxError(_T("BotikKey Pro..."),
												_T("   ."), GetLastError());
							}
							else
							{
								SetDlgItemTextA(hWnd_, IDC_KEY, g_szHash);
							};
						};

						CloseHandle(hFile);
					};
				};
			};
			break; // case IDC_BROWSE

		case IDC_PWD_ASTERISKS_CHECK:
			if(HIWORD(wParam_) == BN_CLICKED)
			{
				g_fPwdAsterisks = (BOOL)SendDlgItemMessage(hWnd_, IDC_PWD_ASTERISKS_CHECK, BM_GETCHECK, 0, 0);
				SendDlgItemMessage(hWnd_, IDC_PASSWD, EM_SETPASSWORDCHAR, 
								   (WPARAM)(g_fPwdAsterisks ? _T('*') : _T(0)), 0);
				SetFocus(GetDlgItem(hWnd_, IDC_PASSWD));
			};
			break;

		case IDC_KEY_ASTERISKS_CHECK:
			if(HIWORD(wParam_) == BN_CLICKED)
			{
				g_fKeyAsterisks = (BOOL)SendDlgItemMessage(hWnd_, IDC_KEY_ASTERISKS_CHECK, BM_GETCHECK, 0, 0);
				SendDlgItemMessage(hWnd_, IDC_KEY, EM_SETPASSWORDCHAR, 
								   (WPARAM)(g_fKeyAsterisks ? _T('*') : _T(0)), 0);
				SetFocus(GetDlgItem(hWnd_, IDC_KEY));
			};
			break;

		case IDC_RADIO1:
		case IDC_RADIO2:
		case IDC_RADIO3:
			if(SendDlgItemMessage(hWnd_, IDC_RADIO1, BM_GETCHECK, 0, 0))
				g_nPasswdPlace = ABK_PASSWD_PLACE_REG;
			else if(SendDlgItemMessage(hWnd_, IDC_RADIO2, BM_GETCHECK, 0, 0))
				g_nPasswdPlace = ABK_PASSWD_PLACE_DEF_FILE;
			else if(SendDlgItemMessage(hWnd_, IDC_RADIO3, BM_GETCHECK, 0, 0))
				g_nPasswdPlace = ABK_PASSWD_PLACE_SELF_FILE;
			else
				g_nPasswdPlace = ABK_PASSWD_PLACE_SELF;

			if(g_nPasswdPlace > 0)
				cfEnableDlgItem(hWnd_, ID_SAVE, TRUE);
			else
				cfEnableDlgItem(hWnd_, ID_SAVE, FALSE);

			break;

		case IDC_PASSWD:
			if(HIWORD(wParam_) == EN_CHANGE)
			{
				LPSTR szPasswd;

				LONG lLen = cfGetDlgItemTextLength(hWnd_, IDC_PASSWD);

				ZeroMemory(g_szHash, sizeof(g_szHash));

				szPasswd = new CHAR[lLen+2];
				GetDlgItemTextA(hWnd_, IDC_PASSWD, szPasswd, lLen+1);
				md5_md5((LPBYTE)szPasswd, (ULONG)strlen(szPasswd), g_szHash);
				delete[] szPasswd;

				SetDlgItemTextA(hWnd_, IDC_KEY, g_szHash);
			};
			break;

		case ID_SAVE:
			{
				LONG lRet;

				if(g_nPasswdPlace == 0)
				{
					MessageBox(NULL, _T("     ."), _T("BotikKey Pro..."), MB_OK|MB_ICONHAND);
					return(TRUE);
				};

				// XXX Localization...
				lRet = MessageBox(NULL, _T(" ,       ?"), _T("BotikKey Pro..."), MB_YESNO|MB_ICONQUESTION);

				if(lRet == IDNO)
					return(TRUE);

				if(g_nPasswdPlace == ABK_PASSWD_PLACE_REG)
				{
					lRet = cfRegSaveSTRVal(g_hKeyLocMch, ABK_BOTIK_KEY_REG_VAR_NAME, g_szHash);
					if(lRet != ERROR_SUCCESS)
					{
						// XXX Localization...
						cfAlertBoxError(_T("BotikKey Pro..."),
										_T("    ."), 
										GetLastError());

						return(TRUE);
					};
				}
				else if(   g_nPasswdPlace == ABK_PASSWD_PLACE_DEF_FILE 
						|| g_nPasswdPlace == ABK_PASSWD_PLACE_SELF_FILE)
				{
					TCHAR szFile[MAX_PATH+1];

					if(g_nPasswdPlace == ABK_PASSWD_PLACE_DEF_FILE)
					{
						TCHAR szModule[MAX_PATH+1];

						GetModuleFileName(g_hInst, szModule, MAX_PATH);

						(*_tcsrchr(szModule, _T('\\'))) = _T(0);

						_tcscpy(szFile, szModule);
						_tcscat(szFile, _T("\\"));
						_tcscat(szFile, ABK_BOTIK_KEY_DEF_FILE_NAME);
					}
					else
					{
						TCHAR	szTitle[MAX_LOADSTRING+1];
						TCHAR	szFilter[MAX_LOADSTRING+1];

						ZeroMemory(szFilter, sizeof(szFilter));
						LoadString(g_hInst, IDS_FILE_FILTER, szFilter, MAX_LOADSTRING);
						LoadString(g_hInst, IDS_OPEN_KEY_FILE_TITLE, szTitle, MAX_LOADSTRING);
						if(!ShowSaveFileDlg(hWnd_, szFile, MAX_PATH, szFilter, szTitle, 0, _T("pswd")))
						{
							return(TRUE);
						};
					};

					// Open|create file and save key.
					HANDLE hFile = CreateFile(szFile, GENERIC_WRITE, FILE_SHARE_READ, NULL, 
											  CREATE_ALWAYS, FILE_ATTRIBUTE_NORMAL, NULL);
					if(hFile == INVALID_HANDLE_VALUE)
					{
						// XXX Localization.
						cfAlertBoxError(_T("BotikKey Pro..."),
										_T("      ."), 
										GetLastError());
						return(TRUE);
					}
					else
					{
						DWORD dwSavedSz;

						WriteFile(hFile, g_szHash, (DWORD)strlen(g_szHash), &dwSavedSz, NULL);
						CloseHandle(hFile);
					};
				}; // if(g_nPasswdPlace == ABK_PASSWD_PLACE_DEF_FILE || g_nPasswdPlace == ABK_PASSWD_PLACE_SELF_FILE)
			}; // case ID_SAVE
			return(TRUE);

		case IDCANCEL:
		case ID_CLOSE:
			DestroyWindow(g_hMainDlg);
			return(TRUE);
		};
		break;

	case WM_DESTROY:
		PostQuitMessage(0);
		break;
	}
	return(FALSE);
};


