/*  BotikKey Pro - Botik Key Client for Windows 9x/ME/NT/2000/XP/2003
 *  Copyright (C) 2004 Alexander V. Melnikoff
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public Licensse as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

#ifndef __EVENTLOG_H__
#define __EVENTLOG_H__

// Message types.
#define BKP_EVENT_TYPE_INFORMATION		0x01 // Service informing about something.
#define BKP_EVENT_TYPE_OK				0x02 // Operation accepted.
#define BKP_EVENT_TYPE_ERROR			0x03 // Error occured.
#define BKP_EVENT_TYPE_MESSAGE			0x04 // Information message.
#define BKP_EVENT_TYPE_NEWVERSION		0x05 // New version essued.

typedef struct _EVENT_LOG_ENTRY
{
#ifdef __BKP_SERVICE__
	_EVENT_LOG_ENTRY*	lpPrevEntry;
	_EVENT_LOG_ENTRY*	lpNextEntry;
#endif // __BKP_SERVICE__
	SYSTEMTIME			stTime;
	DWORD				dwEventType;
	LPTSTR				szMsgText;
} EVENT_LOG_ENTRY, *LPEVENT_LOG_ENTRY;

typedef VOID* HELENTRY;

#define ABK_LOGFILE_ENTRY_DELEMITER		_T("\t")

#define BKP_EVENT_TYPE_STR_INFORMATION	_T("INFO")
#define BKP_EVENT_TYPE_STR_OK			_T("OK")
#define BKP_EVENT_TYPE_STR_ERROR		_T("ERR")
#define BKP_EVENT_TYPE_STR_MESSAGE		_T("MSG")

inline LPTSTR EventLogTypeToString(DWORD dwType_)
{
	LPTSTR szRet = _T("");

	if(dwType_ == BKP_EVENT_TYPE_INFORMATION)
		szRet = BKP_EVENT_TYPE_STR_INFORMATION;
	else if(dwType_ == BKP_EVENT_TYPE_OK)
		szRet = BKP_EVENT_TYPE_STR_OK;
	else if(dwType_ == BKP_EVENT_TYPE_ERROR)
		szRet = BKP_EVENT_TYPE_STR_ERROR;
	else if(dwType_ == BKP_EVENT_TYPE_MESSAGE)
		szRet = BKP_EVENT_TYPE_STR_MESSAGE;

	return(szRet);
};

#ifdef __BKP_SERVICE__

// Event queue to send events to the manager.
extern LPEVENT_LOG_ENTRY	g_lpEventLogHead;
extern LPEVENT_LOG_ENTRY	g_lpEventLogTail;
extern BOOL					g_fWriteLogFile;
extern BOOL					g_fInformMngr;

// Max event queue size.
#define BKP_EVENTLOG_BUFFER_SIZE		50

extern CRITICAL_SECTION		g_csEventLogCritSect;

LPEVENT_LOG_ENTRY EventLogGetEntry();
VOID EventLogFreeEntry(LPEVENT_LOG_ENTRY lpEntry_);
LPEVENT_LOG_ENTRY EventLogAddEntry(DWORD dwEvtType_, LPTSTR szMsgTxt_);
LPEVENT_LOG_ENTRY EventLogAddEntryF(DWORD dwEvtType_, LPCTSTR szFormat_, ...);
VOID EventLogInit(VOID);
VOID EventLogFree(VOID);

#endif // __BKP_SERVICE__

#endif // __EVENTLOG_H__