/*  BotikKey Pro - Botik Key Client for Windows 9x/ME/NT/2000/XP/2003
 *  Copyright (C) 2004 Alexander V. Melnikoff
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public Licensse as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

#include "stdafx.h"
#include <stdio.h>
#include "service.h"
#include "installation.h"

// Global Variables:
HINSTANCE	g_hInst;			// Current instance
BOOL		g_fIsWinNT = FALSE;
BOOL		g_fIs2K = FALSE;

// Forward declaration.
BOOL ShowHelpMessage(VOID);

int APIENTRY _tWinMain(HINSTANCE hInst_, HINSTANCE, LPTSTR lpCmdLine_, INT)
{
	TCHAR szMutexName[MAX_PATH+1];
	OSVERSIONINFO ovi;
	HANDLE hMutex;

 	g_hInst = hInst_;

	cfdprintf(_T("WinMain of BotikKey Pro service [%d]."), GetCurrentThreadId());

	// Get to know what platform we are running on (9x,NT).
	ZeroMemory(&ovi, sizeof(OSVERSIONINFO));
	ovi.dwOSVersionInfoSize = sizeof(OSVERSIONINFO);
	GetVersionEx(&ovi);

	// Check if running platform is suported.
	if(ovi.dwPlatformId == VER_PLATFORM_WIN32s)
	{
		cfAlertBox(EVENTLOG_ERROR_TYPE, ABK_SERVICE_NAME, 
				   _T("This type of Windows platform is not supported."));

		return(1);
	};

	// Get to know we are running on Win9x or WinNT.
	if(ovi.dwPlatformId == VER_PLATFORM_WIN32_NT)
		g_fIsWinNT = TRUE;
	else
		g_fIsWinNT = FALSE;

	// Get to know wa are running on WIn2K or later.
	if(ovi.dwMajorVersion >= 5)
		g_fIs2K = TRUE;
	else 
		g_fIs2K = FALSE;

	// XXX DBG!!!
	//g_fIsWinNT = FALSE;

	// Process command line.
	LPTSTR szTok = _tcstok(lpCmdLine_, _T("-/ "));
	while(szTok)
	{
		cfdprintf("Command: %s", szTok);

		if(!_tcsicmp(szTok, _T("install")))
			return(InstallService());
		else if(!_tcsicmp(szTok, _T("uninstall")))
			return(UnInstallService());
		else if(!_tcsicmp(szTok, _T("start")))
			return(StartService());
		else
			return(ShowHelpMessage());

		szTok = _tcstok(NULL, _T("-/ "));
	};

	// If we are running on Windows 2000 and later, make global mutex.
	if(ovi.dwMajorVersion >= 5)
	{
		_tcscpy(szMutexName, _T("Global\\"));
		_tcscat(szMutexName, ABK_SVC_MUTEX_NAME);
	}
	else
	{
		_tcscpy(szMutexName, ABK_SVC_MUTEX_NAME);
	};

	// Check if this is first instance. If allready there is another instance, exit.
	hMutex = CreateMutex(NULL, FALSE, szMutexName);
	if(GetLastError() != 0)
		return FALSE;

	// Start our service.
	if(g_fIsWinNT)
		ServiceNTStarting();
	else
		Service9xStarting();

	return(0);
};

BOOL ShowHelpMessage(VOID)
{
	cfAlertBox(EVENTLOG_SUCCESS, ABK_SERVICE_NAME, ABK_SVR_HELP_MSG);

	return(TRUE);
};



