/*  BotikKey Pro - Botik Key Client for Windows 9x/ME/NT/2000/XP/2003
 *  Copyright (C) 2004 Alexander V. Melnikoff
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public Licensse as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

#ifndef __SERVICE_H__
#define __SERVICE_H__

#include "resource.h"

extern HINSTANCE	g_hInst;				// Current instance.
extern BOOL			g_fIsWinNT;				// Running platform type.
extern BOOL			g_fIs2K;				// Running system is Win2K or later.
extern CHAR			g_szBotikKey[ABK_MD5_HASH_LEN+2];		// Session access BotikKey (MD5 hash).
extern DWORD		g_dwAccessMode;			// Current network access mode.
extern DWORD		g_dwReqAccessMode;		// Requested access mode.
extern LPSTR		g_szUserMsg;			// User notification message text.
extern DWORD		g_dwUserMsg;			// User notification message code.
extern DWORD		g_dwAccModeWhenDisc;	// Set this access mode when manager disconnects.
extern HKEY			g_hKeyLocMch;			// HKLM reg handle (service config).
extern DWORD		g_nPasswdPlace;			// Access key place holder.
extern DWORD		g_dwSvcSwitchStart;		// Switch to this state when service starts.
extern DWORD		g_dwLastAccessMode;		// Last access mode from config.
extern USHORT		g_nPortNum;				// BotikKey Server port number.
extern LPSTR		g_szSrvAddr;			// BotikKey server address.
extern DWORD		g_dwCurState;			// Current service state.
extern DWORD		g_dwReason;				// Last operation status.

#define ABK_SVC_INTERNAL_ERROR			0x00000001

#define ABK_SVR_HELP_MSG	_T("BotikKey Pro - Alternative Botik Key Client for Windows 9x/ME/NT/2000/XP/2003\n\n\
Usage: bkpsvr32 [--install|--uninstall|--help]\n\n\
--install\t  - Install service;\n\
--uninstall\t  - Uninstall service, if service is running, it will stop them;\n\
--start\t  - Start service;\n\
--help\t  - This help message;\n\n\
If there is no key specified, start service as regular (non service) application.\n\
This feature is applied for Windows 9x/ME operating systems\n\
and doesn't work in Windows NT/2000/XP/2003.")

BOOL ServiceNTStarting(VOID);
BOOL Service9xStarting(VOID);

BOOL ServiceLoadConfig(VOID);
VOID ServiceStopped(VOID);
VOID ServiceStopping(VOID);

BOOL ValidateBotikKey(LPSTR szKey_);

BOOL GetServerAddress();

#endif // __SERVICE_H__